/*

*/

import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use two threads, asynchronous.
  User input on main() thread, factor on second thread.
*/
public class Async3
{
   public static void main(String[] args)
   {
      final Task task = new Task();
      final Thread thread = new Thread(task);
      thread.start();

      final Scanner in = new Scanner(System.in);
      System.out.print("Enter an index of a factor: ");
      int index = in.nextInt();

      try{ thread.join(); }
      catch (InterruptedException e){}

      System.out.println( task.factors );
      System.out.println( task.factors.get(index) );
   }
}


class Task implements Runnable
{
   public List<BigInteger> factors;

   @Override
   public void run()
   {
      factors = Primes.factorize(new BigInteger("100000000000000071"));
   }
}
