/*

*/

import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use two threads, asynchronous.
  Factor on main() thread, user input on second thread.
*/
public class Async4
{
   public static void main(String[] args)
   {
      final Task task = new Task();
      final Thread thread = new Thread(task);
      thread.start();

      final List<BigInteger> factors = Primes.factorize(new BigInteger("100000000000000071"));

      try{ thread.join(); }
      catch (InterruptedException e){}

      System.out.println( factors );
      System.out.println( factors.get(task.index) );
   }
}


class Task implements Runnable
{
   public int index;

   @Override
   public void run()
   {
      final Scanner in = new Scanner(System.in);
      System.out.print("Enter an index of a factor: ");
      index = in.nextInt();
   }
}
