/*

*/

import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use three threads, asynchronous.
  Factor and user input on second and third threads.
*/
public class Async5
{
   public static void main(String[] args)
   {
      final TaskIO taskIO = new TaskIO();
      final Thread threadIO = new Thread(taskIO);
      threadIO.start();

      final TaskFactor taskFactor = new TaskFactor();
      final Thread threadFactor = new Thread(taskFactor);
      threadFactor.start();

      try
      {
         threadIO.join();
         threadFactor.join();
      }
      catch (InterruptedException e){}

      System.out.println( taskFactor.factors );
      System.out.println( taskFactor.factors.get(taskIO.index) );
   }
}

class TaskIO implements Runnable
{
   public int index;

   @Override
   public void run()
   {
      final Scanner in = new Scanner(System.in);
      System.out.print("Enter an index of a factor: ");
      index = in.nextInt();
   }
}

class TaskFactor implements Runnable
{
   public List<BigInteger> factors;

   @Override
   public void run()
   {
      factors = Primes.factorize(new BigInteger("100000000000000071"));
   }
}
