/*

*/

import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use three threads, asynchronous.
  Factor and user input run in a thread pool.
*/
public class Async6
{
   public static void main(String[] args)
   {
      final ExecutorService executor = Executors.newFixedThreadPool(2); // Try just 1 thread!

      final Future<List<BigInteger>> factors = executor.submit(
         () -> Primes.factorize(new BigInteger("100000000000000071"))
      );

      final Future<Integer> index = executor.submit(
         () -> {
                  final Scanner in = new Scanner(System.in);
                  System.out.print("Enter an index of a factor: ");
                  return in.nextInt();
               }
      );

      try
      {
         final int i = index.get();
         final List<BigInteger> f = factors.get();
         System.out.println( f );
         System.out.println( f.get(i) );
      }
      catch(InterruptedException e){}
      catch(ExecutionException e){}

      executor.shutdown();
   }
}
