/*

*/

import java.util.concurrent.ExecutionException;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Future;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use three threads, asynchronous.
  Factor and user input run as CompletableFutures (in the Fork/Join pool).
*/
public class Async7
{
   public static void main(String[] args)
   {
      final Future<List<BigInteger>> factors = CompletableFuture.supplyAsync(
         () -> Primes.factorize(new BigInteger("100000000000000071"))
      );

      final Future<Integer> index = CompletableFuture.supplyAsync(
         () -> {
                  final Scanner in = new Scanner(System.in);
                  System.out.print("Enter an index of a factor: ");
                  return in.nextInt();
               }
      );

      try
      {
         final int i = index.get();
         final List<BigInteger> f = factors.get();
         System.out.println( f );
         System.out.println( f.get(i) );
      }
      catch(InterruptedException e){}
      catch(ExecutionException e){}
   }
}
