/*

*/

import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Future;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.List;

/**
  Use three threads, asynchronous.
  Factor and user input run as CompletableFutures (in a thread pool).
*/
public class Async7a
{
   public static void main(String[] args)
   {
     final ExecutorService executor = Executors.newFixedThreadPool(1); // Try just 1 thread!

      final Future<List<BigInteger>> factors = CompletableFuture.supplyAsync(
         () -> Primes.factorize(new BigInteger("100000000000000071")),
         executor
      );

      final Future<Integer> index = CompletableFuture.supplyAsync(
         () -> {
                  final Scanner in = new Scanner(System.in);
                  System.out.print("Enter an index of a factor: ");
                  return in.nextInt();
               },
         executor
      );

      try
      {
         final int i = index.get();
         final List<BigInteger> f = factors.get();
         System.out.println( f );
         System.out.println( f.get(i) );
      }
      catch(InterruptedException e){}
      catch(ExecutionException e){}

      executor.shutdown();
   }
}
